sentilo-catalog-web/src/main/java/org/sentilo/web/catalog/domain/User.java
/*
 * Sentilo
 *
 * Original version 1.4 Copyright (C) 2013 Institut Municipal d’Informàtica, Ajuntament de
 * Barcelona. Modified by Opentrends adding support for multitenant deployments and SaaS.
 * Modifications on version 1.5 Copyright (C) 2015 Opentrends Solucions i Sistemes, S.L.
 *
 *
 * This program is licensed and may be used, modified and redistributed under the terms of the
 * European Public License (EUPL), either version 1.1 or (at your option) any later version as soon
 * as they are approved by the European Commission.
 *
 * Alternatively, you may redistribute and/or modify this program under the terms of the GNU Lesser
 * General Public License as published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied.
 *
 * See the licenses for the specific language governing permissions, limitations and more details.
 *
 * You should have received a copy of the EUPL1.1 and the LGPLv3 licenses along with this program;
 * if not, you may find them at:
 *
 * https://joinup.ec.europa.eu/software/page/eupl/licence-eupl http://www.gnu.org/licenses/ and
 * https://www.gnu.org/licenses/lgpl.txt
 */
package org.sentilo.web.catalog.domain;

import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.validation.Valid;
import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Pattern;

import org.sentilo.web.catalog.security.Role;
import org.sentilo.web.catalog.utils.Constants;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;

@Document
public class User implements CatalogDocument, TenantResource {

  private static final long serialVersionUID = 1L;

  @Id
  @NotBlank
  @Pattern(regexp = Constants.VALIDATION_USER_NAME_REGEXP)
  private String userName;

  private String password;

  @NotBlank
  private String name;
  private String description;

  @Email
  private String email;

  // Visual configuration of sensor on detail views
  @Valid
  @JsonInclude(value = Include.NON_NULL)
  private VisualConfiguration visualConfiguration;

  @DateTimeFormat(pattern = Constants.DATETIME_FORMAT)
  private Date createdAt;

  private String createdBy;

  @DateTimeFormat(pattern = Constants.DATETIME_FORMAT)
  private Date updatedAt;

  private String updatedBy;

  private boolean active;

  private String tenantId;

  private Set<String> tenantsAuth;

  private Set<String> tenantsListVisible;

  @NotEmpty
  private List<Role> roles;

  public User() {
    tenantsAuth = new HashSet<String>();
    tenantsListVisible = new HashSet<String>();
    visualConfiguration = new VisualConfiguration();
  }

  public User(final String userName) {
    this();
    this.userName = userName;
  }

  @Override
  public boolean equals(final Object obj) {
    if (!(obj instanceof User) || userName == null) {
      return false;
    }
    final User other = (User) obj;
    return userName.equals(other.userName);
  }

  @Override
  public int hashCode() {
    // Hashcode return must be consistent with the equals method
    final int prime = 71;
    int result = 1;
    result = prime * result + (userName == null ? 0 : userName.hashCode());
    return result;
  }

  @Override
  public String getId() {
    return getUserName();
  }

  public String getUserName() {
    return userName;
  }

  public void setUserName(final String userName) {
    this.userName = userName;
  }

  public String getPassword() {
    return password;
  }

  public void setPassword(final String password) {
    this.password = password;
  }

  public String getName() {
    return name;
  }

  public void setName(final String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(final String description) {
    this.description = description;
  }

  public String getEmail() {
    return email;
  }

  public void setEmail(final String email) {
    this.email = email;
  }

  public VisualConfiguration getVisualConfiguration() {
    return visualConfiguration;
  }

  public void setVisualConfiguration(final VisualConfiguration visualConfiguration) {
    this.visualConfiguration = visualConfiguration;
  }

  @Override
  public Date getCreatedAt() {
    return createdAt;
  }

  @Override
  public void setCreatedAt(final Date createdAt) {
    this.createdAt = createdAt;
  }

  public boolean isActive() {
    return active;
  }

  public void setActive(final boolean active) {
    this.active = active;
  }

  public List<Role> getRoles() {
    return roles;
  }

  public void setRoles(final List<Role> roles) {
    this.roles = roles;
  }

  @Override
  public void setUpdatedAt(final Date updatedAt) {
    this.updatedAt = updatedAt;
  }

  @Override
  public Date getUpdatedAt() {
    return updatedAt;
  }

  @Override
  public String getTenantId() {
    return tenantId;
  }

  @Override
  public void setTenantId(final String tenantId) {
    this.tenantId = tenantId;
  }

  @Override
  public Set<String> getTenantsAuth() {
    return tenantsAuth;
  }

  @Override
  public void setTenantsAuth(final Set<String> tenantsAuth) {
    this.tenantsAuth = tenantsAuth;
  }

  @Override
  public Set<String> getTenantsListVisible() {
    return tenantsListVisible;
  }

  @Override
  public void setTenantsListVisible(final Set<String> tenantsListVisible) {
    this.tenantsListVisible = tenantsListVisible;
  }

  @Override
  public String getCreatedBy() {
    return createdBy;
  }

  @Override
  public void setCreatedBy(final String createdBy) {
    this.createdBy = createdBy;
  }

  @Override
  public String getUpdatedBy() {
    return updatedBy;
  }

  @Override
  public void setUpdatedBy(final String updatedBy) {
    this.updatedBy = updatedBy;
  }

}

sentilo-catalog-web/src/main/webapp/WEB-INF/jsp/federation/federation_detail.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@include file="/WEB-INF/jsp/common/header.jsp"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<spring:eval var="showAdminControls" expression="T(org.sentilo.web.catalog.security.SecurityUtils).showAdminControls('READ', 'org.sentilo.web.catalog.domain.FederationConfig')"/>

<spring:url value="/admin/federation/${federationConfig.id}/edit" var="editFederationLink" />
<spring:url value="/admin/federation/list?nameTableRecover=federationTable&fromBack=true" var="backURL" />

<div class="container-fluid">
	<div class="content">
		<div class="row-fluid">
			<div class="span3">
				<%@include file="/WEB-INF/jsp/common/include_sidebar.jsp"%>
			</div>
			<div class="span9">

				<div class="row-fluid">
					<div class="span12">

						<%@include file="/WEB-INF/jsp/common/include_background_logo.jsp"%>
						<%@include file="/WEB-INF/jsp/common/messages.jsp"%>

						<h1 class="lead">
							${federationConfig.name}<br /> <small><spring:message code="id" /> ${federationConfig.id}</small>
						</h1>

						<div class="tabbable">
							<ul class="nav nav-tabs">
								<li class="active"><a href="#tab1" data-toggle="tab"><spring:message code="federation.detail.title" />
								</a></li>
							</ul>
							<div class="tab-content">
								<div class="tab-pane active" id="tab1">
									<div class="accordion" id="detailAccordion">
										<div class="accordion-group">
											<div class="accordion-heading">
												<a class="accordion-toggle" data-toggle="collapse" data-parent="#detailAccordion"
													href="#detailAccordionCollapse"> <i class="icon-th"></i> <spring:message code="data" /> <i
													class="icon-chevron-down pull-right"></i> </a>
											</div>
											<div id="detailAccordionCollapse" class="accordion-body collapse in">
												<div class="accordion-inner">
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="federation.name" /> </strong>
														</div>
														<div class="span8">${federationConfig.name}</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="federation.description" /> </strong>
														</div>
														<div class="span8">${federationConfig.description}</div>
													</div>													
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="federation.createdAt" /> </strong>
														</div>
														<div class="span8">
															<spring:eval expression="federationConfig.createdAt" />
														</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="federation.updatedAt" /> </strong>
														</div>
														<div class="span8">
															<spring:eval expression="federationConfig.updatedAt" />
														</div>
													</div>
													
													<fieldset>
														<legend>
															<spring:message code="federation.service.config.app" />
														</legend>
														<div class="control-group">
															<div class="span4">
																<strong><spring:message code="federation.app_client.name" /> </strong>
															</div>
															<div class="span8">${federationConfig.appClientName}</div>															
														</div>
														<div class="control-group">
															<div class="span4">
																<strong><spring:message code="federation.app_client.token" /> </strong>
															</div>
															<div class="span8">${federationConfig.appClientToken}</div>
														</div>
														<div class="control-group">
															<div class="span4">
																<strong><spring:message code="federation.service.endpoint" /> </strong>
															</div>
															<div class="span8">${federationConfig.sourceEndpoint}</div>																														
														</div>
														<div class="control-group">
															<div class="span4">
																<strong><spring:message code="federation.last_sync" /> </strong>
															</div>
															<div class="span8">
																<spring:eval expression="federationConfig.lastSyncTime" />
															</div>																														
														</div>
													</fieldset>	
													
													<fieldset>
														<legend>
															<spring:message code="federation.service.contact" />
														</legend>
														
														<div class="control-group">
															<div class="span4">
																<strong><spring:message code="federation.service.contact.name" /> </strong>
															</div>
															<div class="span8">${federationConfig.sourceContactName}</div>																														
														</div>
														<div class="control-group">
															<div class="span4">
																<strong><spring:message code="federation.service.contact.email" /> </strong>
															</div>
															<div class="span8">${federationConfig.sourceContactMail}</div>
														</div>
													</fieldset>																									
												</div>
											</div>
										</div>
									</div>
									<div class="row-fluid">
										<div class="span12">
											<div class="control-group pull-right">
												<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
												<c:if test="${showAdminControls}">	
													<a href="${editFederationLink}" class="btn btn-primary"> 
														<spring:message code="federation.edit.title" /> 
													</a>
												</c:if>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<%@include file="/WEB-INF/jsp/common/footer.jsp"%>

sentilo-catalog-web/src/main/webapp/WEB-INF/jsp/federation/federation_list.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@include file="/WEB-INF/jsp/common/header.jsp"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<spring:eval  var="showAdminControls" expression="T(org.sentilo.web.catalog.security.SecurityUtils).showAdminControls('LIST', 'org.sentilo.web.catalog.domain.FederationConfig')"/>

<c:set var="federationTable" value="federationTable"/>

<spring:url value="/admin/federation/delete" var="deleteURL" />
<spring:url value="/admin/federation/" var="federationDetailPrefix" />
<spring:url value="/admin/federation/new" var="newFederationURL" />
<spring:url value="/admin/federation/list/json" var="sAjaxSource" />
<spring:url value="/admin/federation/list/excel?tableName=${federationTable}" var="excelSource" />

<%@include file="/WEB-INF/jsp/common/include_script_tables.jsp"%>
<script type="text/javascript">
$(document).ready(function() {		
	var table =	makeTableAsync('${federationTable}', '${sAjaxSource}', '${federationDetailPrefix}');		
});
</script>

<div class="container-fluid">
	<div class="content">
		<div class="row-fluid">
			<div class="span3">
				<%@include file="/WEB-INF/jsp/common/include_sidebar.jsp"%>
			</div>
			<div class="span9">


				<div class="row-fluid">
					<div class="span12">

						<%@include file="/WEB-INF/jsp/common/include_background_logo.jsp"%>
						<%@include file="/WEB-INF/jsp/common/messages.jsp"%>

						<h1 class="lead">
							<spring:message code="federation.list.title" />
							<br />
						</h1>
						
						<form:form method="post" onkeypress="return preventEnterSubmit(event);" modelAttribute="federations" action="${deleteURL}">

							<table class="table table-striped" id="${federationTable}">
								<thead>
									<tr>
										<td>&nbsp;</td>
										<td><strong><spring:message code="federation.id" /> </strong></td>
										<td><strong><spring:message code="federation.name" /> </strong></td>
										<td><strong><spring:message code="federation.app_client.name" /> </strong></td>										
										<td><strong><spring:message code="federation.last_sync" /> </strong></td>
										<td><strong><spring:message code="federation.createdAt" /> </strong></td>
									</tr>
								</thead>
								<tbody />
							</table>
							<br />
							<div class="control-group pull-left" id="excel_${federationTable}">
								<a href="#" type="button" onclick="window.location.href='${excelSource}';" class="btn"> 
									<spring:message code="button.excel" /> 
								</a>
							</div>
							<c:if test="${showAdminControls}">		
							<div class="control-group pull-right">
								<a href="#" onclick="deleteSelected('federations');" class="btn btn-danger"> 
									<spring:message code="federation.delete.title" /> 
								</a> 
								<a href="#" type="button" onclick="window.location.href='${newFederationURL}';" class="btn"> 
									<spring:message code="federation.new.title" /> 
								</a>
							</div>
							</c:if>
						</form:form>
						
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<%@include file="/WEB-INF/jsp/common/footer.jsp"%>

sentilo-catalog-web/src/main/webapp/WEB-INF/jsp/federation/federation_new.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@include file="/WEB-INF/jsp/common/header.jsp"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<c:if test="${mode == 'edit' }">
	<spring:url value="/admin/federation/${federationConfig.id}/edit" var="actionURL" />
	<spring:message code="federation.edit.title" var="pageTitle" />
	<spring:url value="/admin/federation/${federationConfig.id}/detail" var="backURL" />
	<spring:eval var="showAdminControls" expression="T(org.sentilo.web.catalog.security.SecurityUtils).showAdminControls('EDIT', 'org.sentilo.web.catalog.domain.FederationConfig')"/>	
</c:if>
<c:if test="${mode == 'create' }">
	<spring:url value="/admin/federation/create" var="actionURL" />
	<spring:message code="federation.new.title" var="pageTitle" />
	<spring:url value="/admin/federation/list?nameTableRecover=federationTable&fromBack=true" var="backURL" />
	<spring:eval var="showAdminControls" expression="T(org.sentilo.web.catalog.security.SecurityUtils).showAdminControls('CREATE', 'org.sentilo.web.catalog.domain.FederationConfig')"/>
</c:if>

<c:set var="editMode" value="${mode == 'edit' }" />

<spring:message code="select.empty" var="emptySelectMessage" javaScriptEscape="false" htmlEscape="false"/>


<div class="container-fluid">
	<div class="content">
		<div class="row-fluid">
			<div class="span3">
				<%@include file="/WEB-INF/jsp/common/include_sidebar.jsp"%>
			</div>
			<div class="span9">

				<div class="row-fluid">
					<div class="span12">

						<%@include file="/WEB-INF/jsp/common/include_background_logo.jsp"%>
						<%@include file="/WEB-INF/jsp/common/messages.jsp"%>

						<h1 class="lead">
							${pageTitle}<br />
						</h1>

						<form:form method="post" modelAttribute="federationConfig" action="${actionURL}" class="form-horizontal">
							<fieldset>
								<div class="control-group">
									<form:label path="id" class="control-label">
										<spring:message code="federation.id" />
									</form:label>
									<div class="controls">
										<c:if test="${mode == 'create' }">
											<form:input path="id" />
										</c:if>
										<c:if test="${mode == 'edit' }">
											<form:input path="id" readonly="true" />
											<form:hidden path="createdAt" />
											<form:hidden path="createdBy" />
										</c:if>
										<form:errors path="id" cssClass="text-error" htmlEscape="false" />
									</div>
								</div>
								<div class="control-group">
									<form:label path="name" class="control-label">
										<spring:message code="federation.name" />
									</form:label>
									<div class="controls">
										<form:input path="name" />
										<form:errors path="name" cssClass="text-error" htmlEscape="false" />
									</div>
								</div>
								<div class="control-group">
									<form:label path="description" class="control-label">
										<spring:message code="federation.description" />
									</form:label>
									<div class="controls">
										<form:textarea path="description" />
										<form:errors path="description" cssClass="text-error" htmlEscape="false" />
									</div>
								</div>
								<input type="hidden" id="tenantId" name="tenantId" value="${tenantId}" />
								<fieldset>
									<legend>
										<spring:message code="federation.service.config.app" />
									</legend>
									<div class="control-group">
										<form:label path="appClientName" class="control-label">
											<spring:message code="federation.app_client.name" />
										</form:label>
										<div class="controls">
											<form:input path="appClientName" />
											<form:errors path="appClientName" cssClass="text-error" htmlEscape="false" />
										</div>
									</div>
									<div class="control-group">
										<form:label path="appClientToken" class="control-label">
											<spring:message code="federation.app_client.token" />
										</form:label>
										<div class="controls">
											<form:input path="appClientToken" />
											<form:errors path="appClientToken" cssClass="text-error" htmlEscape="false" />
										</div>
									</div>
									<div class="control-group">
										<form:label path="sourceEndpoint" class="control-label">
											<spring:message code="federation.service.endpoint" />
										</form:label>
										<div class="controls">
											<form:input path="sourceEndpoint" />
											<form:errors path="sourceEndpoint" cssClass="text-error" htmlEscape="false" />
										</div>
									</div>
								</fieldset>	
								
								<fieldset>
									<legend>
										<spring:message code="federation.service.contact" />
									</legend>
									
									<div class="control-group">
										<form:label path="sourceContactName" class="control-label">
											<spring:message code="federation.service.contact.name" />
										</form:label>
										<div class="controls">
											<form:input path="sourceContactName" />
											<form:errors path="sourceContactName" cssClass="text-error" htmlEscape="false" />
										</div>
									</div>
									<div class="control-group">
										<form:label path="sourceContactMail" class="control-label">
											<spring:message code="federation.service.contact.email" />
										</form:label>
										<div class="controls">
											<form:input path="sourceContactMail" />
											<form:errors path="sourceContactMail" cssClass="text-error" htmlEscape="false" />
										</div>
									</div>
								</fieldset>	
																
								<div class="control-group">
									<div class="controls">
										<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
										<c:if test="${showAdminControls}">
										<a href="#"
											onclick="$('form#federationConfig').submit();" class="btn btn-success"> <spring:message code="button.save" />
										</a>
										</c:if>
									</div>
								</div>
							</fieldset>

						</form:form>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<%@include file="/WEB-INF/jsp/common/footer.jsp"%>